package com.websystique.xml;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;

import org.joda.time.LocalDate;

import com.websystique.xml.model.Student;

public class JaxbAnnotationsDemo {

	public static void main(String[] args) throws JAXBException{

		Student s = new Student();
		s.setFirstName("Alan");
		s.setLastName("Turing");
		s.setSection("Computer Science");
		s.setDob(new LocalDate(1956, 10, 1));
		s.setId(1);
	
		List<String> subjects = new ArrayList<String>();
		subjects.add("Maths");
		subjects.add("Science");
		subjects.add("Economics");

		List<String> groups = new ArrayList<String>();
		groups.add("Techies");
		groups.add("Volunteers");
		
		s.setGroups(groups);
		s.setSubjects(subjects);

		// create JAXB context
		JAXBContext context = JAXBContext.newInstance(Student.class);

		System.out.println("<!----------Generating the XML Output-------------->");
		
		// Marshalling [Generate XML from JAVA]
		// create Marshaller using JAXB context
		Marshaller m = context.createMarshaller();
		// To format the [to be]generated XML output
		m.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
		// Marshall it and write output to System.out or to a file
		m.marshal(s, System.out);
	}

}
